
C     SPACEM  94  , 2me module      Outils divers

	INCLUDE 'spacem.fi'

C-----------------------------------------------------------------------

C---- Transf est une routine qui transforme les coordonnes cristallo en
C     orthonormes

	SUBROUTINE transf (x, u, a, nato)

c---- a orthogonal = proj. de a tricl. sur ox orthogonal = a triclinique
c     b orthogonal = proj. de b tricl. sur oy orthogonal
c     c orthogonal = proj. de c tricl. sur oz orthogonal

	IMPLICIT   none
	INTEGER*2  NMAX
	PARAMETER (NMAX = 999)
	REAL       a (6), b (6), c (6), x (3, NMAX), u (3, NMAX)
	REAL       pi, sg, v
	INTEGER*2  i, ii, j, l, nato, nat

	pi = 0.0174532925

	a (4) = cos (a (4)*pi)
	a (5) = cos (a (5)*pi)
	a (6) = cos (a (6)*pi)

	sg = sqrt (1.0-a (6)**2)
	v = a (1)*a (2)*a (3)
     &      *sqrt (1.0-a (4)**2-a (5)**2+2.0*a (4)*a (5)*a (6)-a (6)**2)

	b (1) = a (1)
	b (2) = a (2)*a (6)
	b (3) = a (3)*a (5)
	b (4) = a (2)*sg
	b (5) = -a (3)*(a (5)*a (6)-a (4))/sg
	b (6) = v/(a (2)*a (1)*sg)

	c (1) = 1.0/a (1)
	c (2) = -a (6)/(a (1)*sg)
	c (3) = a (3)*a (2)*(a (4)*a (6)-a (5))/(v*sg)
	c (4) = 1.0/(a(2)*sg)
	c (5) = a (3)*a (1)*(a (5)*a (6)-a (4))/(v*sg)
	c (6) = a (2)*a (1)*sg/v

	DO ii = 1, nato
	  i = nato+1-ii
	  DO j = 1,3
	    x (j, i+3) = x (j, i)
	  ENDDO
	ENDDO

	x (1, 1) = 1.0
	x (2, 1) = 0.
	x (3, 1) = 0.
	x (1, 2) = 0.
	x (2, 2) = 1.0
	x (3, 2) = 0.
	x (1, 3) = 0.
	x (2, 3) = 0.
	x (3, 3) = 1.0
	nat = nato+3

c----passage triclinique - orthonorme
	DO l = 4, nat
	  i = l-3
	  u (1, i) = b (1)*x (1, l)+b (2)*x (2, l)+b (3)*x (3, l)
	  u (2, i) = b (4)*x (2, l)+b (5)*x (3, l)
	  u (3, i) = b (6)*x (3, l)
	ENDDO
	END

c***********************************************************************
c-----Subroutine Graphicsmode pour fixer le mode graphique, ainsi que la
c     palette de couleurs

	SUBROUTINE graphicsmode ()

	IMPLICIT   none
	INCLUDE   'spacem.fd'
	INTEGER*2  dummy
	INTEGER*4  rvb

	dummy = setvideomode ($VRES16COLOR)             ! VGA 16 couleurs
	IF (dummy .EQ. 0) dummy = setvideomode ($VRES2COLOR) ! monochrome
	IF (dummy .EQ. 0) THEN                            !  tout hasard
	  WRITE (*, *) 'ERREUR : impossible de passer en mode graphique'
	  STOP
     &  'Ce programme recquiert une carte VGA 16 couleurs ou suprieure'
	ENDIF

c-----Etablissement d'une palette de couleurs adapte aux molcules
c     organiques.
C     (l'indice 0 est le $BLUE (cf setbkcolor))
	   dummy = remappalette (0 ,rvb (08, 08, 35)) ! bleu     fond d'cran
	 dummy = remappalette (1 ,rvb (63, 63, 63)) ! blanc       hydrogne
	 dummy = remappalette (2 ,rvb (25, 25, 25)) ! gris          carbone
	 dummy = remappalette (3 ,rvb (10, 10, 63)) ! bleu            azote
	 dummy = remappalette (4 ,rvb (63, 20, 00)) ! rouge         oxygne
	 dummy = remappalette (5 ,rvb (58, 63, 20)) ! jaune-vert      fluor
	 dummy = remappalette (6 ,rvb (45, 00, 10)) ! carmin      phosphore
C                  on ne remappe pas l'index 7, c'est le blanc standard,
C                                       couleur par dfaut du mode texte
	 dummy = remappalette (8 ,rvb (63, 45, 00)) ! jaune          soufre
	 dummy = remappalette (9 ,rvb (00, 63, 20)) ! vert           chlore
	 dummy = remappalette (10,rvb (63, 00, 32)) ! fuchsia         brome
	 dummy = remappalette (11,rvb (50, 22, 05)) ! brun             iode
	 dummy = remappalette (12,rvb (00, 63, 63)) ! cyan  textes de menus
	 dummy = remappalette (13,rvb (00, 00, 00)) ! noir
	 dummy = remappalette (14,rvb (10, 36, 00)) ! vert           angles
	 dummy = remappalette (15,rvb (44, 44, 44)) ! gris tout autre atome
	END

c-----------------------------------------------------------------------
C     Fonction Rvb, accepte les valeurs de rouge, bleu, vert et les mixe
C     en une valeur de couleur pour remapper une palette.

	INTEGER*4 FUNCTION rvb (r, v, b)

	IMPLICIT  none
	INTEGER*4 r, v, b

	rvb = ((256*b .OR. v)*256) .OR. r

	END

C-------------------------------------------------------------------------

c-----Subroutine Defcouleurs pour crer la table des couleurs

	SUBROUTINE   defcouleurs

	IMPLICIT     none
	INTEGER*2    NMAX
	PARAMETER   (NMAX = 999)

	INTEGER*2    iat (NMAX), kiat (NMAX), jcolo (NMAX), indc
	INTEGER*2    nbatom, ntyp, noper, nosymb, i
	REAL         xyz (3, NMAX)
	STRUCTURE   /sphcoord/
	  INTEGER*2  a (3)
	  REAL       c (3)
	END STRUCTURE
	RECORD      /sphcoord/ rtp (NMAX)

	REAL         size, scal, perdis
	COMMON /caract/      nbatom, indc
	COMMON /color/       jcolo
	COMMON /paramdessin/ ntyp, noper, nosymb, kiat, size, scal, perdis
	COMMON /sph/         xyz, iat, rtp

	IF (ntyp .EQ. 0) THEN
	  DO i = 1, nbatom
	    SELECT CASE (iat (i))
		CASE (1)
		  jcolo(i) = 1        !           hydrogne
		CASE (6)
		  jcolo(i) = 2        !             carbone
		CASE (7)
		  jcolo(i) = 3        !               azote
		CASE (8)
		  jcolo(i) = 4        !             oxygne
		CASE (9)
		  jcolo(i) = 5        !               fluor
		CASE (15)
		  jcolo(i) = 6        !           phosphore
		CASE (16)
		  jcolo(i) = 8        !              soufre
		CASE (17)
		  jcolo(i) = 9        !              chlore
		CASE (35)
		  jcolo(i) = 10       !               brome
		CASE (53)
		  jcolo(i) = 11       !                iode
		CASE DEFAULT
		 jcolo (i) = 15       !  couleur par dfaut
	     END SELECT
	  ENDDO
	ELSE
	  DO i = 1, nbatom
	    jcolo (i) = kiat (i)
	  ENDDO
	ENDIF

	END

C-----------------------------------------------------------------------

c-----Subroutine Premiere ; c'est la page de presentation

	SUBROUTINE   premiere ()

	IMPLICIT     none
	INCLUDE     'spacem.fd'
	INTEGER*2    delay, m1, m2, m3, m4, dummy, i
	CHARACTER*20 police
	CHARACTER*1  touche, readkey
	LOGICAL      keypressed, out

	RECORD /xycoord/ s

C-----charger la police 'roman' et crire dans cette police tout ce qui
C     doit l'tre
	dummy = registerfonts ('roman.fon')
	IF (dummy .LT. 0) GOTO 100
	police = "t'roman'"//'h280w63b'
	dummy = setfont (police)
	IF (dummy .LT. 0) THEN
	  CALL unregisterfonts ()
	  GOTO 100
	ENDIF

	dummy = setcolor (3)                              !  plat en bleu
	CALL moveto (17, 7, s)
	CALL outgtext ('Spacem 94')

	DO i = 1, 8
	  dummy = setcolor (2)                        ! une couche de gris
	  CALL moveto (18-i, 8-i, s)
	  CALL outgtext ('Spacem 94')
	  dummy = setcolor (3)                     ! et une couche de bleu
	  CALL moveto (17-i, 7-i, s)
	  CALL outgtext ('Spacem 94')
	  dummy = delay (0.02)
	ENDDO

	police = "t'roman'"//'h10w13b'
	dummy = setfont (police)
	dummy = setcolor (2)                                     ! ombrage
	CALL moveto (14, 256, s)
	CALL outgtext ('v 1.11')
	dummy = setcolor (3)                                    ! criture
	CALL moveto (12, 254, s)
	CALL outgtext ('v 1.11')

	police = "t'roman'"//'h19w14b'
	dummy = setfont (police)
	dummy = setcolor (2)                                     ! ombrage
	CALL moveto (37, 326, s)
	CALL outgtext ('G.M. Smith (1977), H.A. Clark & D. Henry (1982)')
	CALL moveto (37, 391, s)
	CALL outgtext ('H. Vivier, M.N. Pons, ENSIC Nancy')
	CALL moveto (37, 456, s)
	CALL outgtext ('Ch. Courtois & J.-Y. Rehby, ENSIC Nancy, 1994')
	dummy = setcolor (8)     ! criture
	CALL moveto (35, 324, s)
	CALL outgtext ('G.M. Smith (1977), H.A. Clark & D. Henry (1982)')
	CALL moveto (35, 389, s)
	CALL outgtext ('H. Vivier, M.N. Pons, ENSIC Nancy')
	CALL moveto (35, 454, s)
	CALL outgtext ('Ch. Courtois & J.-Y. Rehby, ENSIC Nancy, 1994')
	dummy = setcolor (2)       ! ombrage
	police = "t'roman'"//'h19w12b'
	dummy = setfont (police)
	CALL moveto (12, 297, s)
	CALL outgtext ('Programme Space :')
	CALL moveto (12, 362, s)
	CALL outgtext ('Version adapte sur PC et Compatibles par :')
	CALL moveto (12, 427, s)
	CALL outgtext ('Modifications pour molcules organiques :')
	dummy = setcolor (9)
	CALL moveto (10, 295, s)
	CALL outgtext ('Programme Space :')
	CALL moveto (10, 360, s)
	CALL outgtext ('Version adapte sur PC et Compatibles par :')
	CALL moveto (10, 425, s)
	CALL outgtext ('Modifications pour molcules organiques :')

	CALL unregisterfonts ()

C-----mme principe avec la police 'modern'
 100  CONTINUE
	dummy = registerfonts ('modern.fon')
	IF (dummy .LT. 0) RETURN
	police = "t'modern'"//'h30w10b'
	dummy = setfont (police)
	IF (dummy .LT. 0) THEN
	  CALL unregisterfonts ()
	  RETURN
	ENDIF

	dummy = setcolor (2)
	DO i = 1, 3
	  CALL moveto (124-i, 244-i, s)
	  CALL outgtext
     &        ('Edition et Reprsentation de Molcules en 3 Dimensions')
	ENDDO
	dummy = setcolor (9)
	CALL moveto (120, 240, s)
	CALL outgtext
     &        ('Edition et Reprsentation de Molcules en 3 Dimensions')

	m1 = 0                                     ! initialiser la souris
	CALL souris (m1, m2, m3, m4)
	CALL allumers

	m2 = 0
	out = .FALSE.
	DO WHILE (.NOT. (m2 .EQ. 1 .OR. out))
	   CALL activers (m1, m2, m3, m4)
	   out = keypressed ()
	ENDDO

	IF (out) THEN
	   touche = readkey ()
	   IF (ICHAR (touche) .EQ. 0) touche = readkey () !! vider buffer
	ELSE
	   CALL relax (m3, m4)
	ENDIF

	CALL eteindres

	END


C-----------------------------------------------------------------------

	INTEGER*2 FUNCTION delay (duree)

C-----Fonction delay : effectue un boucle de temps, avec sortie quand
C     dure secondes sont passes

	IMPLICIT  none

	REAL      duree                       ! Dclaration des paramtres

	INTEGER*2 ihr, imin, isec, i100th              !   Dclaration des
	REAL*8    nbsec, origine, delta                ! variables locales

	CALL gettim (ihr, imin, isec, i100th)    ! Rcupration de l'heure

C-----Calcul du nombre de secondes  partir de minuit
	origine = DBLE (ihr)*3600 + DBLE (imin)*60 + DBLE (isec)
     &        + DBLE (i100th)/100
	delta = 0
	DO WHILE (delta .LT. duree)
	   CALL gettim (ihr, imin, isec, i100th)
	   nbsec = DBLE (ihr)*3600 + DBLE (imin)*60 + DBLE (isec)
     &         + DBLE (i100th)/100
	   delta = nbsec-origine           ! Calcul de la dure en seconde
	ENDDO
	delay = 0

	END

C-----------------------------------------------------------------------

	SUBROUTINE    centro (yy, chaine, largo)

c   Centro est une routine qui centre la chane envoye sur la ligne yy
c   de l'cran. Il faut prciser largo, qui est la largeur de la fentre
c   d'affichage (en colonnes texte). Si largo <= 0, il est pass d'offi-
c   ce  80 colonnes. On obtiendra une abscisse >= 1 ; attention aux
c   chanes trop longues.

	IMPLICIT      none
	CHARACTER*(*) chaine
	INTEGER*2     xx, yy, longch        ! ncessite la fonction longch
	INTEGER*2     largo

	IF (largo .LE. 0) largo = 80
	xx = (largo - longch (chaine))/2+1            ! calcule l'abscisse
	IF (xx .LE. 0) xx = 1                                  !   xx >= 1
	CALL texto (yy, xx, chaine)                            ! affichage

	END
C-----------------------------------------------------------------------

	SUBROUTINE       texto (yy, xx, chaine)

c   La subroutine texto affiche caractre par caractre, soigneusement 
c   l'endroit spcifi.
c   Elle remplace settextposition et outtext et vite les dbordements
c   de la chane  afficher sur le reste (espaces excdentaires en bout
c   de chane).

	IMPLICIT         none
	INCLUDE         'spacem.fd'

	CHARACTER*(*)    chaine
	INTEGER*2        xx, yy, i, longch  ! ncessite la fonction longch
	RECORD /xycoord/ xy

	DO i = 1, longch (chaine)
	  CALL settextposition (yy, xx+i-1, xy)
	  CALL outtext (chaine (i:i))
	ENDDO

	END

c-----------------------------------------------------------------------

	INTEGER*2     FUNCTION longch (chaine)

c-----Renvoie la longueur REELLE d'une chane

	INTEGER*2     lt, c
	CHARACTER*(*) chaine

	lt = len (chaine)
	longch = lt

	c = ICHAR (chaine (lt:lt))
	DO WHILE (.NOT. (c .GT. 32) .AND. longch .GT. 0)
c.... Diminue longch tant qu'il trouve des espaces en bout de chane
	  longch = longch-1
	  c = ICHAR (chaine (longch:longch))
	ENDDO

	END

c-----------------------------------------------------------------------

	SUBROUTINE geti (integ, wg, line, col)

c  La subroutine Geti renvoie :
c  un integer saisi au clavier dans integ et wg = .FALSE.
c  En cas de saisie rate (saisie vide, chaine de caractres...) elle
c  renvoie :
c  integ = 0 et wg = .TRUE.

	IMPLICIT  none
	INTEGER*2 integ, line, col
	REAL      float
	LOGICAL   wg

	integ = 0
	CALL getf (float, wg, line, col)
	IF (wg) RETURN
	integ = int (float)
	END


c-----------------------------------------------------------------------

	SUBROUTINE   getf (float, wg, line, colonne)

c  La subroutine Getf renvoie :
c  un real saisi au clavier dans float et wg = .FALSE.
c  En cas de saisie rate (saisie vide, chaine de caractres...) elle
c  renvoie :
c  float = 0 et wg = .TRUE.
c  accessoirement elle rpond aux petits messages que peuvent lui sussurer
c  certains professeurs d'informatique de l'ENSIC...

	IMPLICIT     none
	INCLUDE     'spacem.fd'
	INTEGER*2    BRIGHT
	PARAMETER   (BRIGHT = 1)
	INTEGER      plante
	INTEGER*2    ok, icar, tx, ty, line, colonne, dummy2
	REAL         float
	LOGICAL      wg
	CHARACTER*78 chaine

	wg = .FALSE.
	float = 0.0
	ok = 1
	chaine = ' '

READ (*, '(a)', ERR = 9999, IOSTAT = plante) chaine

	tx = 40 - colonne
	ty = 4
	CALL SetTextWindow (line, colonne, line+ty, 40)
	CALL Input (icar, chaine, tx, ty)
	CALL SetTextWindow (4, 1, 30, 40)
	dummy2 = SetTextColor (BRIGHT)

IF (plante .NE. 0) GOTO 9999
	IF (    index (chaine, 'onjour') .GT. 0) THEN
	  CALL ShortAlertBox ('Bonjour !', ' ','&OK ', ' ', ok)
	ELSEIF (index (chaine, 'anane') .GT. 0) THEN
	  CALL ShortAlertBox
     &                 ('C''est bon les bananes !', ' ', '&OK', ' ', ok)
	ELSEIF (index (chaine, 'oncombre') .GT. 0) THEN
	  CALL ShortAlertBox
     &             ('J''aime pas les concombres !', ' ', '&OK', ' ', ok)
	ELSE
	   READ (chaine, '(f10.0)', IOSTAT = plante) float
	   IF (plante .EQ. 0) RETURN
	ENDIF

	wg = .TRUE.

	END
