
C     SPACEM 94 , 4me module               Cart

C***********************************************************************
C
C     CART.FOR fut annex  Spacem94 en tant que 4me module lors des
C     modifications de Spacem par Ch. Courtois & J-Y. Rehby
C                    ( janvier - avril 1994 )
C Modifications en MS-Fortran 5.0, en programmation moins dstructure ;
C seul le calcul mathmatique central a t rcupr ; l'essentiel du
C listing originel a t supprim. Les routines de chargement et sauve-
C garde de fichiers  la suite n'ont plus qu'un lointain rapport avec
C celles de Cart.
C
C***********************************************************************
C                        ex - PROGRAMME CART
C              VERSION COMPLETEE PAR THEOBALD LE 27 09 76
C
C     CE PROGRAMME CALCULE EN FORTRAN H, LES COORDONNEES CARTESIENNES
C     DES ATOMES
C***********************************************************************

      SUBROUTINE  Cart (err)

      IMPLICIT    none
      INTEGER*2   NMAX
      PARAMETER  (NMAX = 999)

      STRUCTURE /sphcoord/
        INTEGER*2 a (3)
        REAL      c (3)
      END STRUCTURE
      RECORD /sphcoord/ rtp (NMAX)
      REAL        xyz (3, NMAX), r, te, ph, conv
      REAL*8      cm (3), t (3, 3), vca (3), rja (3)
      REAL*8      cs, ss, dsq, rab, scale, raj, cs1, ss1
      INTEGER*2   iat (NMAX)
      INTEGER*2   err, indc, nbatom, i, j, k, no, na, nb, nc

      COMMON /sph/    xyz, iat, rtp
      COMMON /caract/ nbatom, indc

      conv=3.14159265358979/180.       ! facteur de conversion  <-> rad

C-----Sinus et cosinus pour l'angle 109 degrs 28 minutes :
      cs1 = -1.d0/3.d0
      ss1 = -2.d0*dsqrt (2.d0)*cs1

C-----Initialisation du compteur et du code d'erreur :
      no  = 1
      err = 0

C-----Initialisation des coordonnes cartsiennes :
      DO i = 1, nbatom
        DO j = 1, 3
          xyz (j, i) = .0
        ENDDO
      ENDDO

C-----Pour chaque atome...
      DO WHILE (nbatom .GE. no)

C...... passage  Cart des donnes sphriques, d'une faon apparente 
C       une lecture sur fichier interne, et contrle de la validit de
C       la chaine de dfinition :
        na = rtp (no).a (1)
        IF ((na .EQ. 0 .AND. no .GT. 1) .OR. na .GE. no) THEN
          err = 1
          RETURN
        ENDIF

        nb = rtp (no).a (2)
        IF (    (nb .EQ. 0 .AND. no .GT. 2)
     &      .OR. nb .GE. no .OR. (nb .EQ. na .AND. nb .NE. 0)) THEN
           err = 1
           RETURN
        ENDIF

        nc = rtp (no).a (3)
        IF (    (nc .EQ. 0 .AND. no .GT. 3)
     &      .OR. nc .GE. no
     &      .OR. ((nc .EQ. na .OR. nc .EQ. nb) .AND. nc .NE. 0)) THEN
          err = 1
          RETURN
        ENDIF
        r  = rtp (no).c (1)
        te = rtp (no).c (2)
        ph = rtp (no).c (3)

C                  *********************************
C                 CALCUL DES COORDONNEES CARTESIENNES
C     Donnes ncessaires :
C       - longueur de liaison r entre l'atome no et l'atome na,
C       - angle valentiel te entre no-na-nb,
C       - angle didre orient ph entre les plans no-na-nb et na-nb-nc
C     Dfinition du systme d'axes Oxyz orthonorm :
C       - atome 1  l'origine O,
C       - atome 2 sur la partie positive de Ox,
C       - atome 3 positionn par rapport  l'atome 2. Les atomes
C         1, 2, 3 forment un plan et Oy est orient de telle sorte que 3
C         se trouve dans le premier cadran,
C       - axe Oz perpendiculaire au plan Oxy.
C                  *******************************

        IF (no .GE. 3) THEN

          IF (te .EQ. 0.) THEN  ! angle 0 interprt comme valant 109.466
            cs = cs1
            ss = ss1
          ELSE
            cs = cos (conv*te)
            ss = sin (conv*te)
          ENDIF

          IF (no .GT. 3) THEN

            dsq = 0.d0
            DO j = 1, 3
              cm (j) = xyz (j, nb)-xyz (j, na)
              vca (j) = xyz (j, nc)-xyz (j, na)
              dsq = dsq+cm (j)**2
            ENDDO

            rab = dsqrt (dsq)
            scale = 0.d0
            DO j = 1, 3
              t (j, 1) = cm (j)/rab
              scale = scale+t (j, 1)*vca (j)
            ENDDO

            dsq = 0.d0
            DO j = 1, 3
              rja (j) = vca (j)-scale*t (j, 1)
              dsq = dsq+rja (j)**2
            ENDDO

            raj = dsqrt (dsq)
            DO j = 1, 3
              t (j, 2) = rja (j)/raj
            ENDDO

            t (1, 3) = t (2, 1)*t (3, 2)-t (3, 1)*t (2, 2)
            t (2, 3) = t (3, 1)*t (1, 2)-t (1, 1)*t (3, 2)
            t (3, 3) = t (1, 1)*t (2, 2)-t (2, 1)*t (1, 2)
            rja (1) = r*cs
            rja (2) = r*ss*dcos (conv*ph)
            rja (3) = r*ss*dsin (conv*ph)
            DO j = 1, 3
              xyz (j, no) = xyz (j, na)
              DO k = 1, 3
                xyz (j, no) = xyz (j, no)+t (j, k)*rja (k)
              ENDDO
            ENDDO

          ELSE                                          ! IF (no .EQ. 3)
            IF (na .EQ. 1) THEN
              xyz (1, no) = xyz (1, na)+r*cs
            ELSE
              xyz (1, no) = xyz (1, na)-r*cs
            ENDIF
            xyz (2, no) = r*ss
          ENDIF

        ELSEIF (no .EQ. 2) THEN
            xyz (1, no) = r
        ENDIF
        no = no+1
      ENDDO                            ! fin de la boucle sur les atomes

      END                                                  ! fin de Cart

C=======================================================================

      SUBROUTINE litsph (typeload, err)

C----Lit les coordonnes sphriques des atomes dans un fichier.
C    Typeload indique quel fichier on charge (normal, undo)

      IMPLICIT       none

      INTEGER*2      NMAX
      PARAMETER     (NMAX = 999)

      STRUCTURE /sphcoord/
        INTEGER*2 a (3)
        REAL      c (3)
      END STRUCTURE
      RECORD /sphcoord/ rtp (NMAX)
      REAL           xyz (3, NMAX)
      INTEGER*2      ia1 (NMAX), ia2 (NMAX), iat (NMAX), indc, nundo
      INTEGER*1      natli (NMAX)
      INTEGER*2      nbatom, i, j, numato, nbliai, typeload, type
      INTEGER        plante
      INTEGER*2      err   ! renvoie l'erreur de lecture
                           ! 0 = aucune, 1 = numrotation, 2 = autre
      CHARACTER*78   nomfich
      CHARACTER*32   titre
      CHARACTER*12   undofile
      LOGICAL        liaisauto

      COMMON /sph/    xyz, iat, rtp
      COMMON /liais/  nbliai, ia1, ia2, natli, liaisauto
      COMMON /caract/ nbatom, indc
      COMMON /titel/  titre, nomfich
      COMMON /undofile/ nundo

c----- Initialiser
      CALL initcoord
      err = 0

c----- Procder au chargement (de quel fichier ?)
      IF (typeload .EQ. 0) THEN
        OPEN (23, FILE = nomfich)
      ELSE
        WRITE (undofile, '(a, i1, a)') 'spaundo', nundo, '.tmp'
        OPEN (23, FILE = undofile, IOSTAT = plante)
      ENDIF

      READ (23, '(a)', IOSTAT = plante) titre

      IF (plante .EQ. 0) THEN
         READ (23, *, IOSTAT = plante) nbatom

         IF (plante .EQ. 0) THEN
            DO i = 1, nbatom
               READ (23, *, IOSTAT = plante)
     &            numato, (rtp (i).a (j), j = 1, 3),
     &                    (rtp (i).c (j), j = 1, 3), iat (i)
               IF (i .NE. numato) THEN
                  err = 1
                  EXIT
               ENDIF
               IF (plante .NE. 0) EXIT

            ENDDO
            IF (plante .EQ. 0 .AND. err .EQ. 0) THEN
               READ (23, *, IOSTAT = plante) nbliai
               IF (plante .EQ. 0) THEN
                  DO i = 1, nbliai
                     READ (23, *, IOSTAT = plante)
     &                               ia1 (i), ia2 (i), natli (i)
                     IF (plante .NE. 0) EXIT
                  ENDDO
               ENDIF
            ENDIF
         ENDIF
      ENDIF

      CLOSE (23)

      IF (plante .NE. 0 .AND. err .EQ. 0) err = 2

      IF (err .NE. 0) THEN
         CALL initcoord
      ELSE
c        Aprs avoir charg une molcule, on la resauve pour l'undo
         CALL ClasseLiaisons
         type = 1
         IF (typeload .EQ. 0) CALL sauvesph (type, err)
      ENDIF

      END

C=======================================================================

      SUBROUTINE    initcoord

C  Nettoie le tableau des coordonnes

      IMPLICIT      none

      INTEGER*2     NMAX
      PARAMETER    (NMAX=999)

      STRUCTURE /sphcoord/
        INTEGER*2  a (3)
        REAL       c (3)
      END STRUCTURE
      RECORD /sphcoord/ rtp (NMAX)
      INTEGER*2     ia1 (NMAX), ia2 (NMAX), iat (NMAX), indc
      INTEGER*1     natli (NMAX)
      INTEGER*2     nbatom, i, j, nbliai
      REAL          xyz (3, NMAX)
      LOGICAL       liaisauto
      CHARACTER*32  titre
      CHARACTER*78  nomfich

      COMMON /sph/    xyz, iat, rtp
      COMMON /liais/  nbliai, ia1, ia2, natli, liaisauto
      COMMON /caract/ nbatom, indc
      COMMON /titel/  titre, nomfich

      titre = ' '
      IF (nbatom .GT. 0) THEN
        DO i = 1, nbatom   ! ici c'est le vieux nbatom s'il existe ;
                           ! on initialise pour virer la molcule en cours
          DO j = 1, 3
            rtp (i).a (j) = 0
            rtp (i).c (j) = 0.0
            xyz (j, i) = 0.0
          ENDDO
        ENDDO
      ENDIF
      nbatom = 0

      IF (nbliai .GT. 0) THEN  ! idem pour les liaisons
        DO i = 1, nbliai
          ia1 (i) = 0
          ia2 (i) = 0
          natli (i) =0
        ENDDO
      ENDIF
      nbliai = 0
      END

C=======================================================================

      SUBROUTINE     sauvesph (typesave, err)

      IMPLICIT       none

      INTEGER*2      NMAX
      PARAMETER     (NMAX=999)

      STRUCTURE /sphcoord/
        INTEGER*2    a (3)
        REAL         c (3)
      END STRUCTURE
      RECORD /sphcoord/ rtp (NMAX)
      INTEGER*2      ia1 (NMAX), ia2 (NMAX), iat (NMAX)
      INTEGER*2      err, indc, nundo
      INTEGER*1      natli (NMAX)
      INTEGER*2      nbatom, i, j, nbliai, typesave
      INTEGER        plante
      REAL           xyz (3, NMAX)
      CHARACTER*78   nomfich
      CHARACTER*32   titre
      CHARACTER*12   undofile
      LOGICAL        liaisauto, undook

      COMMON /sph/    xyz, iat, rtp
      COMMON /liais/  nbliai, ia1, ia2, natli, liaisauto
      COMMON /caract/ nbatom, indc
      COMMON /titel/  titre, nomfich
      COMMON /undo/   undook
      COMMON /undofile/ nundo

c  typesave = 0 si sauvegarde de nomfich
c           = 1 si sauvegarde du undo
c           = 2 si sauvegarde de dboguage

      IF (typesave .EQ. 0) THEN
        OPEN (23, FILE = nomfich, IOSTAT = plante)
      ELSE IF (typesave .EQ. 1) THEN

        WRITE (undofile, '(a, i1, a)') 'spaundo', nundo, '.tmp'
        OPEN (23, FILE = undofile, IOSTAT = plante)
        undook = .TRUE.
      ELSE
        OPEN (23, FILE = 'spadebog.tmp', IOSTAT = plante)
      ENDIF

      IF (plante .EQ. 0) THEN
         WRITE (23, '(a)', IOSTAT = plante) titre
         IF (plante .EQ. 0) THEN
            WRITE (23, *, IOSTAT = plante) nbatom

            IF (plante .EQ. 0) THEN

C....       crit le numro d'atome, les 3 atomes de rfrence et
C           les 3 angles, puis le n atomique

               DO i = 1, nbatom
                 WRITE (23, '(4(I3,1X),3(F8.3,1X),I3)', IOSTAT = plante)
     &                             i, (rtp (i).a (j), j = 1, 3),
     &                                (rtp (i).c (j), j = 1, 3), iat (i)
                 IF (plante .NE. 0) EXIT
               ENDDO

               IF (plante .EQ. 0) THEN
C....             crit les liaisons :
C                 atomes de dpart, arrive, nature (simple, double...)

                 WRITE (23, *, IOSTAT = plante) nbliai

                 IF (plante .EQ. 0) THEN

                   DO i = 1, nbliai
                     WRITE (23, *, IOSTAT = plante)
     &                                       ia1 (i), ia2 (i), natli (i)
                     IF (plante .NE. 0) EXIT
                   ENDDO
                 ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDIF

      IF (plante .NE. 0) err = 1

      CLOSE (23)
      END

C=======================================================================

      SUBROUTINE LitCar (option, err)

C-----Il s'agit de l'ancienne partie de lecture des coordonnes cart-
C     siennes ou cristallographiques de SPACEM, du temps o ce dernier
C     ne savait pas en lire d'un autre type.

C    (NB : la version avec les liaisons doubles, triples... a t
C          supprime pour la compatibilit avec les vieux .D )

      IMPLICIT     none

      INTEGER*2    NMAX
      PARAMETER   (NMAX = 999)

      STRUCTURE /sphcoord/
        INTEGER*2  a (3)
        REAL       c (3)
      END STRUCTURE
      RECORD /sphcoord/ rtp (NMAX)
      REAL         xyz (3, NMAX), u (3, NMAX), a (6)
      REAL         cxyz (3, NMAX)
      REAL         size, scal, perdis
      REAL         radii (NMAX), rion (10)
      INTEGER*1    natli (NMAX)
      INTEGER*2    ia1 (NMAX), ia2 (NMAX), iat (NMAX), kiat (NMAX)
      INTEGER*2    iovrlp (NMAX), inters (NMAX)
      INTEGER*2    option, err, indc, nbatom, nbliai 
      INTEGER      plante
      INTEGER*2    i, j, ntyp, noper, nosymb, nint, nlaps
      CHARACTER*78 nomfich
      CHARACTER*32 titre
      LOGICAL      liaisauto

      COMMON /sph/    xyz, iat, rtp
      COMMON /liais/  nbliai, ia1, ia2, natli, liaisauto
      COMMON /atom/   cxyz, radii, iovrlp, nlaps, inters, nint, rion
      COMMON /caract/ nbatom, indc
      COMMON /titel/  titre, nomfich
      COMMON /paramdessin/ ntyp, noper, nosymb, kiat, size, scal, perdis

c---- Initialisation
      DO i = 1, 10
        rion (i) = 0.0
      ENDDO
      DO i = 1, NMAX
        kiat (i) = 0
      ENDDO

      IF (nbatom .NE. 0) THEN
        DO i = 1, nbatom
          DO j = 1, 3
            xyz (j, i) = 0.0
          ENDDO
        ENDDO
        nbatom = 0
      ENDIF
      IF (nbliai .NE. 0) THEN
        DO i = 1, nbliai
          ia1 (i) = 0
          ia2 (i) = 0
          natli (i) =0
        ENDDO
        nbliai = 0
      ENDIF

c---- On ouvre le fichier

      OPEN (101, FILE = nomfich)

c---- nbatom = nombre d'atomes ; ntyp : nombre de type d'ions
c     noper  option avec (0) ou sans (1) perspective
c     nosymb option avec (1) ou sans (0) symbole

      READ (101,*, IOSTAT=plante) nbatom, ntyp, noper, nosymb
c-----xyz=position de l'atome, iat type de l'atome (numro atomique)
c     kiat: type d'ion de l'atome introduit
c     (si kiat=0  rayon de Van der Waals)

c-----lecture des paramtres de la maille

c.....Si option 2 (cristallo)
      IF (option .EQ. 2)
     &            READ (101, *, IOSTAT = plante) (a (i), i=1, 6)

      IF (plante .NE. 0) THEN
         err = 1            ! erreur de lecture des paramtres de maille
      ELSE

         IF (ntyp .NE. 0) THEN
            READ (101, *, IOSTAT = plante)
     &   (u (1, i), u (2, i), u (3, i), iat (i), kiat(i), i = 1, nbatom)
         ELSE
            READ (101, *, IOSTAT = plante)
     &            (u (1, i), u (2, i), u (3, i), iat (i), i = 1, nbatom)
         ENDIF

         IF (plante .NE. 0) THEN

            err = 2                  ! erreur de lecture des coordonnes

         ELSE

C.....     Si on a lu des coordonnes cartsiennes
           IF (option .EQ. 1) THEN
             DO i = 1, nbatom
                DO j = 1, 3
                   xyz (j, i) = u (j, i)
                ENDDO
             ENDDO
           ELSE
c.....     Si on a lu des coordonnes cristallo.
             CALL transf (u, xyz, a, nbatom)
           ENDIF


           READ (101, *, IOSTAT = plante) nbliai  ! = nombre de liaisons

                   ! liaisons entre atome numro ia1 et atome numro ia2
           READ (101, *, IOSTAT = plante)
     &                                 (ia1 (i), ia2 (i), i = 1, nbliai)

           IF (plante .NE. 0) THEN
              err = 3                   ! erreur de lecture des liaisons
           ELSE

c-----        lecture des rayons ioniques si ntyp diffrent de 0
             IF (ntyp .NE. 0) THEN
                READ (101, *, IOSTAT = plante) (rion (i), i = 1, ntyp)
                IF (plante .NE. 0) THEN
                   err = 4       ! erreur de lecture des rayons ioniques
                ENDIF
             ENDIF
           ENDIF
         ENDIF
      ENDIF


      IF (err .NE. 0) THEN
C-----  Faire comme si on n'avait rien lu du tout.
 9988   IF (nbatom .NE. 0) THEN
          DO i = 1, nbatom
            DO j = 1, 3
              xyz (j, i) = 0
            ENDDO
          ENDDO
          nbatom = 0
        ENDIF
        IF (nbliai .NE. 0) THEN
          DO i = 1, nbliai
            ia1 (i) = 0
            ia2 (i) = 0
            natli (i) =0
          ENDDO
          nbliai = 0
        ENDIF
      ELSE
         titre = nomfich
                ! faute de mieux, on prend comme titre le nom du fichier
      ENDIF

      CLOSE (1)

C-----Retour  l'appelant

      END

C=======================================================================
C     La subroutine Tracs qui suit ralise la conversion
C     cartsienne --> sphrique, tant donn un systme d'atomes
C     de rfrence.

      SUBROUTINE  tracs (nbatom, err)

      IMPLICIT    none
      INTEGER*2   NMAX
      PARAMETER  (NMAX = 999)
      STRUCTURE  /sphcoord/
         INTEGER*2 a (3)
         REAL      c (3)
      END STRUCTURE
      RECORD /sphcoord/ rtp (NMAX)
      REAL        xyz (3, NMAX)
      REAL*8      x1, y1, z1, x2, y2, z2, rp, pi
      REAL*8      r1, r2, r3, t1, t2, t3, to, test
      REAL*8      xi, xi1, xi2, xj, xj1, xj2, xk, xk1, xk2, xl, xl1, xl2
      INTEGER*2   iat (NMAX), j_, k_, l_, m_, err
      INTEGER*2   i_, nbatom
      COMMON /sph/ xyz, iat, rtp

      pi = 3.14159265358979323d0/180.d0
      err = 0

      DO i_ = 1, nbatom

         j_ = rtp (i_).a (1)
         k_ = rtp (i_).a (2)
         l_ = rtp (i_).a (3)
         r1 = 0.d0
         t1 = 0.d0

         IF (j_ .EQ. 0) THEN                             ! premier atome
             to = 0.d0

         ELSEIF (k_ .EQ. 0) THEN                        ! deuxime atome
             DO m_ = 1, 3
                r1 = r1+dble ((xyz (m_, i_)-xyz (m_, j_))**2)
             ENDDO
             r1 = dsqrt (r1)
             to = 0.d0

         ELSEIF (l_ .EQ. 0) THEN                       ! troisime atome
             r2 = 0.d0
             DO m_ = 1, 3
                xi = dble (xyz (m_, i_))
                xj = dble (xyz (m_, j_))
                xk = dble (xyz (m_, k_))
                r1 = r1+(xi-xj)**2
                r2 = r2+(xj-xk)**2
                t1 = t1+(xj-xi)*(xj-xk)
             ENDDO
             r1 = dsqrt (r1)
             r2 = dsqrt (r2)

             t1 = t1/(r1*r2)
             CALL tttt (t1, err)
             IF (err .NE. 0) RETURN
             t1 = dacos (t1)/pi
             to = 0.d0

         ELSE                                          ! quatrime atome
             r2 = 0.d0                                 !     et suivants
             r3 = 0.d0
             t2 = 0.d0
             t3 = 0.d0
             DO m_ = 1, 3
                xi = dble (xyz (m_, i_))
                xj = dble (xyz (m_, j_))
                xk = dble (xyz (m_, k_))
                xl = dble (xyz (m_, l_))
                r1 = r1+(xi-xj)**2
                r2 = r2+(xj-xk)**2
                r3 = r3+(xj-xl)**2
                t1 = t1+(xj-xi)*(xj-xk)
                t2 = t2+(xj-xi)*(xj-xl)
                t3 = t3+(xj-xk)*(xj-xl)
             ENDDO

             r1 = dsqrt (r1)
             r2 = dsqrt (r2)
             r3 = dsqrt (r3)
             t1 = t1/(r1*r2)
             t2 = t2/(r1*r3)
             t3 = t3/(r2*r3)
             to = (t2-t1*t3)/dsqrt((1.d0-t1**2)*(1.d0-t3**2))

             CALL tttt (t1, err)
             IF (err .NE. 0) RETURN
             t1 = dacos (t1)/pi

             CALL tttt (to, err)
             IF (err .NE. 0) RETURN
             to = dacos (to)/pi

             xi1 = dble (xyz (1, i_))
             xi2 = dble (xyz (2, i_))
             xi  = dble (xyz (3, i_))
             xj1 = dble (xyz (1, j_))
             xj2 = dble (xyz (2, j_))
             xj  = dble (xyz (3, j_))
             xk1 = dble (xyz (1, k_))
             xk2 = dble (xyz (2, k_))
             xk  = dble (xyz (3, k_))
             xl1 = dble (xyz (1, l_))
             xl2 = dble (xyz (2, l_))
             xl  = dble (xyz (3, l_))

              ! produit vectoriel ji ^ jl

             x2 = (xi2-xj2)*(xl -xj ) - (xi -xj )*(xl2-xj2)
             y2 = (xi1-xj1)*(xl -xj ) - (xi -xj )*(xl1-xj1)
             z2 = (xi1-xj1)*(xl2-xj2) - (xl1-xj1)*(xi2-xj2)

              ! produit scalaire du prcdent par jk

             test = (xk1-xj1)*x2-(xk2-xj2)*y2+(xk-xj)*z2

             IF (test .GT. 0.d0) THEN
                to = -to

             ELSEIF (test .EQ. 0.d0) THEN       ! cas de 4 atomes  plat
                rp = 0.d0

                 ! produit vectoriel jk ^ ji

                x1 = (xk2-xj2)*(xi -xj ) - (xk -xj )*(xi2-xj2)
                y1 = (xk -xj )*(xi1-xj1) - (xk1-xj1)*(xi -xj )
                z1 = (xk1-xj1)*(xi2-xj2) - (xk2-xj2)*(xi1-xj1)

                 ! produit vectoriel jk ^ jl

                x2 = (xk2-xj2)*(xl -xj ) - (xk -xj )*(xl2-xj2)
                y2 = (xk -xj )*(xl1-xj1) - (xk1-xj1)*(xl -xj )
                z2 = (xk1-xj1)*(xl2-xj2) - (xk2-xj2)*(xl1-xj1)

                 ! produit scalaire des deux vecteurs ci-dessus

                rp = x1*x2 + y1*y2 + z1*z2


                IF (rp .LT. 0.d0) THEN
                   to = 180.d0

                ELSEIF (rp .GE. 0.d0) THEN
                   to = 0.d0

                ENDIF
             ENDIF
         ENDIF
         rtp (i_).c (1) = real (r1)
         rtp (i_).c (2) = real (t1)
         rtp (i_).c (3) = real (to)
      ENDDO
      END

C---- Subroutine tttt, destine  rcuprer une ventuelle incongrut dans
C     les calculs (arccosinus d'un rel suprieur  1)

      SUBROUTINE tttt (a_, err)
      IMPLICIT   none
      REAL*8     a_
      INTEGER*2  err

      IF (dabs (a_) .LE. 1.01d0) THEN
         IF (a_ .GT.  1.d0) THEN
            a_ = 1.d0
         ELSEIF (a_ .LT. -1.d0) THEN
            a_ = -1.d0
         ENDIF
         err = 0
      ELSE
         err = 1
      ENDIF
      END

